力扣日记4.10-【动态规划篇】343. 整数拆分

力扣日记:【动态规划篇】343. 整数拆分

日期:2024.4.10

参考:代码随想录、力扣

343. 整数拆分

题目描述

难度:中等

给定一个正整数 n ,将其拆分为 k 个 正整数 的和( k >= 2 ),并使这些整数的乘积最大化。

返回 你可以获得的最大乘积 。

示例 1:

输入: n = 2

输出: 1

解释: 2 = 1 + 1, 1 × 1 = 1。

示例 2:

输入: n = 10

输出: 36

解释: 10 = 3 + 3 + 4, 3 × 3 × 4 = 36。

提示:

  • 2 <= n <= 58

题解

cpp ver
cpp 复制代码
class Solution {
public:
    int integerBreak(int n) {
        /* 
        思路:求一个数拆分之后能得到的最大乘积:则可以尝试把该数拆成2个数、3个数、...等,分别看各种情况的值,再取最大值
        这里运用动规的关键是,怎么用递推关系表示拆分
        首先定义dp[i] 表示将 i 拆分之后(注意dp包含了拆分的意味) 可以获得的最大乘积
        则对一个数 i , 其拆分可表示为两种情况:
        一是拆成两个数,即 j * (i - j)(这里 j 从 1 遍历到 i-2 ,因为 i - j 要 >= 2 才有意义)
        二是拆成三个数及以上,表示为 j * dp[i-j] (注意 dp[i-j] 包含了将 i-j 拆成更小的数的情况)
        而至于 j 拆成更小的数的情况,已经包含在遍历过程中 遍历到 j-1,j-2 等的情况里了
        所以 dp[i] = max_j { max{j*(i-j), j*dp[i-j]} } 注意有两层max,即先从两种情况下选出最大值,再找到哪一个j对应的dp[i]最大
        */
        // 定义 dp 数组
        vector<int> dp(n + 1);
        // 初始化,这里dp[0]和dp[1]没有意义,因为不能拆分,所以从2开始初始化
        dp[2] = 1; // 2 只能拆成2个1,不能包含在递推中
        // 遍历:对 i 从 3 遍历到 n;对 j 从 1 遍历到 i-2(如果要优化,可以遍历到 i/2,因为只有让拆出来的数尽可能大小接近,才能得到最大乘积)
        for (int i = 3; i <= n; i++) {  // 遍历 i 得到 dp[i]
            int max_dp_i = 0;
            for (int j = 1; j <= i - 2; j++) { // 遍历 j,看 j 取哪一个值能得到 dp[i] 的最大值
                int cur_dp_i = max(j * (i - j), j * dp[i - j]);
                max_dp_i = max(cur_dp_i, max_dp_i);  // 看当前j对应的dp[i]是否是最大dp[i]
                // 也可以直接表示成 dp[i] = max(dp[i], max(j * (i - j), j * dp[i - j]))
            }
            dp[i] = max_dp_i;   // 记录max_dp_i为真正的dp[i]
        }
        return dp[n];
    }
};

复杂度

时间复杂度:O(n * n)

空间复杂度:O(n)

思路总结

  • 思路:求一个数拆分之后能得到的最大乘积:则可以尝试把该数拆成2个数、3个数、...等,分别看各种情况的值,再取最大值
  • 这里运用动规的关键是,怎么用递推关系表示拆分
    • 首先定义dpi 表示将 i 拆分之后(注意dp包含了拆分的意味) 可以获得的最大乘积
    • 则对一个数 i , 其拆分可表示为两种情况:
      • 一是拆成两个数,即 j * (i - j)(这里 j 从 1 遍历到 i-2 ,因为 i - j 要 >= 2 才有意义)
      • 二是拆成三个数及以上,表示为 j * dpi-j (注意 dpi-j 包含了将 i-j 拆成更小的数的情况)
      • 而至于 j 拆成更小的数的情况,已经包含在遍历过程中 遍历到 j-1,j-2 等的情况里了
    • 所以 dp[i] = max_j { max{j*(i-j), j*dp[i-j]} }
      • 注意有两层max,即先从两种情况下选出最大值,再找到哪一个j对应的dpi最大
相关推荐
Nil20816 小时前
leetcode 118杨辉三角
算法·leetcode·职场和发展
wanderist.18 小时前
线性筛法详解:从筛质数到欧拉函数、Möbius 函数与约数函数
java·数据结构·算法
All for pursuit.18 小时前
【设计-1】208.实现Trie (前缀树)
数据结构·c++·算法·leetcode
weixin_3077791318 小时前
C++代码实现MATLAB中的crossval函数功能
开发语言·c++·算法·matlab
青少儿编程课堂18 小时前
背包问题(0/1 背包与完全背包)解题精讲——动态规划入门
c++·python·算法·bfs·信息学竞赛
光影少年19 小时前
为什么 JavaScript 中 0.1 + 0.2 !== 0.3,如何让其相等?
前端·javascript·算法
HEJOO919 小时前
Linux 设备驱动系列——使用全局工作队列
java·linux·算法
Code_Solitude19 小时前
c语言:递归
java·c语言·算法
edtoplort20 小时前
OpenAI紧急叫停GPT-6.1 Astra训练,奥尔特曼为何踩刹车
人工智能·gpt·算法
蒜香可达鸭20 小时前
让视频生成流水线跑不崩:一个事件溯源的多 Agent 可靠执行框架
算法